1. 程式人生 > >【LeetCode】62. Unique Paths(C++)

【LeetCode】62. Unique Paths(C++)

地址:https://leetcode.com/problems/unique-paths/

題目:

A robot is located at the top-left corner of a m n m * n grid (marked ‘Start’ in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked ‘Finish’ in the diagram below).

How many possible unique paths are there?
在這裡插入圖片描述
Above is a 7 x 3 grid. How many possible unique paths are there?
Note: m and n will be at most 100.
Example 1

:

Input: m = 3, n = 2
Output: 3
Explanation:
From the top-left corner, there are a total of 3 ways to reach the bottom-right corner:

  1. Right -> Right -> Down
  2. Right -> Down -> Right
  3. Down -> Right -> Right

Example 2:

Input: m = 7, n = 3
Output: 28

理解:

用dp做就可以了。當前位置的可能等於從左邊過來和從上面過來兩種,則到達當前位置可能數就是dp[i-1][j]和dp[i][j-1]之和。

實現:

自己的實現,比較笨

class Solution {
public:
	int uniquePaths(int m, int n) {
		if (m == 1 || n == 1) return 1;
		vector<vector<int>> dp(n, vector<int>(m,0));
		dp[0][1] = dp[1][0] = 1;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				int left = i >= 1 ? dp[i - 1][j] : 0;
				int top = j >= 1 ? dp[i][j - 1] : 0;
				dp[i][j] = left + top + dp[i][j];
			}
		}
		return dp[n - 1][m - 1];
	}
};

別人的實現

class Solution {
public:
	int uniquePaths(int m, int n) {
		vector<vector<int>> dp(n, vector<int>(m,1));
		for (int i = 1; i < n; ++i) {
			for (int j = 1; j < m; ++j) {
				dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
			}
		}
		return dp[n - 1][m - 1];
	}
};

但事實上,我們在每次迴圈中只用到了當前行和上一行,因此可以壓縮空間複雜度。
if (m > n) return uniquePaths(n, m);是為了節約空間。

class Solution {
public:
	int uniquePaths(int m, int n) {
		if (m > n) return uniquePaths(n, m);
		vector<int> pre(m, 1), curr(m, 1);
		for (int i = 1; i < n; ++i) {
			for (int j = 1; j < m; ++j) {
				curr[j] = curr[j - 1] + pre[j];
			}
			swap(curr, pre);
		}
		return pre[m - 1];
	}
};

交換操作把curr換到了pre,而pre[0]永遠都是0,後面的已經沒有用了。
然而,交換操作也是多餘的。因為curr是從左到右更新,因此還可以節約一個數組的空間。

class Solution {
public:
	int uniquePaths(int m, int n) {
		if (m > n) return uniquePaths(n, m);
		vector<int> dp(m, 1);
		for (int i = 1; i < n; ++i) {
			for (int j = 1; j < m; ++j) {
				dp[j] += dp[j - 1];
			}
		}
		return dp[m - 1];
	}
};